﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.ObjectModel;


namespace AppReviews
{
    public class AppsData : INotifyPropertyChanged
    {
        public AppsData()
        {
            this.Apps = new ObservableCollection<ApplicationData>();
        }

        /// <summary>
        /// A collection for ItemViewModel objects.
        /// </summary>
        public ObservableCollection<ApplicationData> Apps { get; private set; }

        /// <summary>
        /// Creates and adds a few ItemViewModel objects into the Items collection.
        /// </summary>
        public void LoadData(ApplicationData appToLoadFirst, bool preloadAppNameFirst)
        {
            if (appToLoadFirst != null)
            {
                appToLoadFirst.LoadDataFirstPass(preloadAppNameFirst);
            }

            foreach (ApplicationData app in Apps)
            {
                if (app != appToLoadFirst)
                {
                    app.LoadDataFirstPass(preloadAppNameFirst);
                }
            }

            if (appToLoadFirst != null)
            {
                appToLoadFirst.LoadDataSecondPass(preloadAppNameFirst);
            }

            foreach (ApplicationData app in Apps)
            {
                if (app != appToLoadFirst)
                {
                    app.LoadDataSecondPass(preloadAppNameFirst);
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}