﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace AppReviews
{
    public class ReviewData : INotifyPropertyChanged
    {
        private string _marketName;
        public string MarketName
        {
            get
            {
                return _marketName;
            }
            set
            {
                if (value != _marketName)
                {
                    _marketName = value;
                    NotifyPropertyChanged("MarketName");
                }
            }
        }

        private string _author;
        public string Author
        {
            get
            {
                return _author;
            }
            set
            {
                if (value != _author)
                {
                    _author = value;
                    NotifyPropertyChanged("Author");
                }
            }
        }

        private string _title;
        public string Title
        {
            get
            {
                return _title;
            }
            set
            {
                if (value != _title)
                {
                    _title = value;
                    NotifyPropertyChanged("Title");
                }
            }
        }

        private string _reviewText;
        public string ReviewText
        {
            get
            {
                return _reviewText;
            }
            set
            {
                if (value != _reviewText)
                {
                    _reviewText = value;
                    NotifyPropertyChanged("ReviewText");
                }
            }
        }

        private string _dateString;
        /// <summary>
        /// Rating date
        /// </summary>
        /// <returns></returns>
        public string DateString
        {
            get
            {
                return _dateString;
            }
        }

        private DateTime _date;
        public DateTime Date
        {
            get
            {
                return _date;
            }
            set
            {
                if (value != _date)
                {
                    _date = value;
                    _dateString = _date.ToShortDateString();
                    NotifyPropertyChanged("Date");
                    NotifyPropertyChanged("DateString");
                }
            }
        }

        private double _rating;
        /// <summary>
        /// Rating in stars (0..5)
        /// </summary>
        /// <returns></returns>
        public double Rating
        {
            get
            {
                return _rating;
            }
            set
            {
                if (value != _rating)
                {
                    _rating = value;
                    NotifyPropertyChanged("Rating");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}