﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace AppReviews
{
    public partial class ErrorControl : StackPanel
    {
        public ErrorControl()
        {
            InitializeComponent();
        }

        private string _errorMessage = null;
        public string ErrorMessage
        {
            get
            {
                return _errorMessage;
            }
            set
            {
                if (_errorMessage == value) return;
                _errorMessage = value;
                UpdateErrorView();
            }
        }

        public void UpdateErrorView()
        {
            if (string.IsNullOrEmpty(_errorMessage))
            {
                this.Visibility = Visibility.Collapsed;
            }
            else
            {
                textError.Text = _errorMessage;
                this.Visibility = Visibility.Visible;
            }
        }

        private void panelError_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            ErrorMessage = null;
        }
    }
}
